Package org.springframework.cache.support

# Class NoOpCache

java.lang.Object
org.springframework.cache.support.NoOpCache

All Implemented Interfaces:
  `Cache`

public class NoOpCache extends Object implements Cache
A no operation `Cache` implementation suitable for disabling caching.

Will simply accept any items into the cache not actually storing them.

Since:
  4.3.4
Author:
  Costin Leau, Stephane Nicoll
See Also:
  - `NoOpCacheManager`

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.springframework.cache.Cache

`Cache.ValueRetrievalException, Cache.ValueWrapper`

## Constructor Summary

Constructors
Constructor
Description
`NoOpCache(String name)`
Create a `NoOpCache` instance with the specified name.

## Method Summary

Modifier and Type
Method
Description
`void`
`clear()`
Clear the cache through removing all mappings.
`void`
`evict(Object key)`
Evict the mapping for this key from this cache if it is present.
`boolean`
`evictIfPresent(Object key)`
Evict the mapping for this key from this cache if it is present, expecting the key to be immediately invisible for subsequent lookups.
`Cache.ValueWrapper`
`get(Object key)`
Return the value to which this cache maps the specified key.
`<T> T`
`get(Object key, Class<T> type)`
Return the value to which this cache maps the specified key, generically specifying a type that return value will be cast to.
`<T> T`
`get(Object key, Callable<T> valueLoader)`
Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary.
`String`
`getName()`
Return the cache name.
`Object`
`getNativeCache()`
Return the underlying native cache provider.
`boolean`
`invalidate()`
Invalidate the cache through removing all mappings, expecting all entries to be immediately invisible for subsequent lookups.
`void`
`put(Object key, Object value)`
Associate the specified value with the specified key in this cache.
`Cache.ValueWrapper`
`putIfAbsent(Object key, Object value)`
Atomically associate the specified value with the specified key in this cache if it is not set already.
`CompletableFuture<?>`
`retrieve(Object key)`
Return the value to which this cache maps the specified key, wrapped in a `CompletableFuture`.
`<T> CompletableFuture<T>`
`retrieve(Object key, Supplier<CompletableFuture<T>> valueLoader)`
Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### NoOpCache

public NoOpCache(String name)
Create a `NoOpCache` instance with the specified name.

Parameters:
  `name` - the name of the cache

## Method Details

### getName

public String getName()
Description copied from interface: `Cache`
Return the cache name.

Specified by:
  `getName` in interface `Cache`

### getNativeCache

public Object getNativeCache()
Description copied from interface: `Cache`
Return the underlying native cache provider.

Specified by:
  `getNativeCache` in interface `Cache`

### get

@Nullable public Cache.ValueWrapper get(Object key)
Description copied from interface: `Cache`
Return the value to which this cache maps the specified key.

Returns `null` if the cache contains no mapping for this key; otherwise, the cached value (which may be `null` itself) will be returned in a `Cache.ValueWrapper`.

Specified by:
  `get` in interface `Cache`
Parameters:
  `key` - the key whose associated value is to be returned
Returns:
  the value to which this cache maps the specified key, contained within a `Cache.ValueWrapper` which may also hold a cached `null` value. A straight `null` being returned means that the cache contains no mapping for this key.
See Also:
  - `Cache.get(Object, Class)`
  - `Cache.get(Object, Callable)`

### get

@Nullable public <T> T get(Object key, @Nullable Class<T> type)
Description copied from interface: `Cache`
Return the value to which this cache maps the specified key, generically specifying a type that return value will be cast to.

Note: This variant of `get` does not allow for differentiating between a cached `null` value and no cache entry found at all. Use the standard `Cache.get(Object)` variant for that purpose instead.

Specified by:
  `get` in interface `Cache`
Parameters:
  `key` - the key whose associated value is to be returned
  `type` - the required type of the returned value (may be `null` to bypass a type check; in case of a `null` value found in the cache, the specified type is irrelevant)
Returns:
  the value to which this cache maps the specified key (which may be `null` itself), or also `null` if the cache contains no mapping for this key
See Also:
  - `Cache.get(Object)`

### get

@Nullable public <T> T get(Object key, Callable<T> valueLoader)
Description copied from interface: `Cache`
Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary. This method provides a simple substitute for the conventional "if cached, return; otherwise create, cache and return" pattern.

If possible, implementations should ensure that the loading operation is synchronized so that the specified `valueLoader` is only called once in case of concurrent access on the same key.

If the `valueLoader` throws an exception, it is wrapped in a `Cache.ValueRetrievalException`

Specified by:
  `get` in interface `Cache`
Parameters:
  `key` - the key whose associated value is to be returned
Returns:
  the value to which this cache maps the specified key
See Also:
  - `Cache.get(Object)`

### retrieve

@Nullable public CompletableFuture<?> retrieve(Object key)
Description copied from interface: `Cache`
Return the value to which this cache maps the specified key, wrapped in a `CompletableFuture`. This operation must not block but is allowed to return a completed `CompletableFuture` if the corresponding value is immediately available.

Can return `null` if the cache can immediately determine that it contains no mapping for this key (for example, through an in-memory key map). Otherwise, the cached value will be returned in the `CompletableFuture`, with `null` indicating a late-determined cache miss. A nested `Cache.ValueWrapper` potentially indicates a nullable cached value; the cached value may also be represented as a plain element if null values are not supported. Calling code needs to be prepared to handle all those variants of the result returned by this method.

Specified by:
  `retrieve` in interface `Cache`
Parameters:
  `key` - the key whose associated value is to be returned
Returns:
  the value to which this cache maps the specified key, contained within a `CompletableFuture` which may also be empty when a cache miss has been late-determined. A straight `null` being returned means that the cache immediately determined that it contains no mapping for this key. A `Cache.ValueWrapper` contained within the `CompletableFuture` indicates a cached value that is potentially `null`; this is sensible in a late-determined scenario where a regular CompletableFuture-contained `null` indicates a cache miss. However, a cache may also return a plain value if it does not support the actual caching of `null` values, avoiding the extra level of value wrapping. Spring's cache processing can deal with all such implementation strategies.
See Also:
  - `Cache.retrieve(Object, Supplier)`

### retrieve

public <T> CompletableFuture<T> retrieve(Object key, Supplier<CompletableFuture<T>> valueLoader)
Description copied from interface: `Cache`
Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary. This method provides a simple substitute for the conventional "if cached, return; otherwise create, cache and return" pattern, based on `CompletableFuture`. This operation must not block.

If possible, implementations should ensure that the loading operation is synchronized so that the specified `valueLoader` is only called once in case of concurrent access on the same key.

Null values always indicate a user-level `null` value with this method. The provided `CompletableFuture` handle produces a value or raises an exception. If the `valueLoader` raises an exception, it will be propagated to the returned `CompletableFuture` handle.

Specified by:
  `retrieve` in interface `Cache`
Parameters:
  `key` - the key whose associated value is to be returned
Returns:
  the value to which this cache maps the specified key, contained within a `CompletableFuture` which will never be `null`. The provided future is expected to produce a value or raise an exception.
See Also:
  - `Cache.retrieve(Object)`
  - `Cache.get(Object, Callable)`

### put

public void put(Object key, @Nullable Object value)
Description copied from interface: `Cache`
Associate the specified value with the specified key in this cache.

If the cache previously contained a mapping for this key, the old value is replaced by the specified value.

Actual registration may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly not seeing the entry yet. This may for example be the case with transactional cache decorators. Use `Cache.putIfAbsent(java.lang.Object, java.lang.Object)` for guaranteed immediate registration.

If the cache is supposed to be compatible with `CompletableFuture` and reactive interactions, the put operation needs to be effectively non-blocking, with any backend write-through happening asynchronously. This goes along with a cache implemented and configured to support `Cache.retrieve(Object)` and `Cache.retrieve(Object, Supplier)`.

Specified by:
  `put` in interface `Cache`
Parameters:
  `key` - the key with which the specified value is to be associated
  `value` - the value to be associated with the specified key
See Also:
  - `Cache.putIfAbsent(Object, Object)`

### putIfAbsent

@Nullable public Cache.ValueWrapper putIfAbsent(Object key, @Nullable Object value)
Description copied from interface: `Cache`
Atomically associate the specified value with the specified key in this cache if it is not set already.

This is equivalent to:

     ValueWrapper existingValue = cache.get(key);
     if (existingValue == null) {
         cache.put(key, value);
     }
     return existingValue;

except that the action is performed atomically. While all out-of-the-box `CacheManager` implementations are able to perform the put atomically, the operation may also be implemented in two steps, for example, with a check for presence and a subsequent put, in a non-atomic way. Check the documentation of the native cache implementation that you are using for more details.

The default implementation delegates to `Cache.get(Object)` and `Cache.put(Object, Object)` along the lines of the code snippet above.

Specified by:
  `putIfAbsent` in interface `Cache`
Parameters:
  `key` - the key with which the specified value is to be associated
  `value` - the value to be associated with the specified key
Returns:
  the value to which this cache maps the specified key (which may be `null` itself), or also `null` if the cache did not contain any mapping for that key prior to this call. Returning `null` is therefore an indicator that the given `value` has been associated with the key.
See Also:
  - `Cache.put(Object, Object)`

### evict

public void evict(Object key)
Description copied from interface: `Cache`
Evict the mapping for this key from this cache if it is present.

Actual eviction may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly still seeing the entry. This may for example be the case with transactional cache decorators. Use `Cache.evictIfPresent(java.lang.Object)` for guaranteed immediate removal.

If the cache is supposed to be compatible with `CompletableFuture` and reactive interactions, the evict operation needs to be effectively non-blocking, with any backend write-through happening asynchronously. This goes along with a cache implemented and configured to support `Cache.retrieve(Object)` and `Cache.retrieve(Object, Supplier)`.

Specified by:
  `evict` in interface `Cache`
Parameters:
  `key` - the key whose mapping is to be removed from the cache
See Also:
  - `Cache.evictIfPresent(Object)`

### evictIfPresent

public boolean evictIfPresent(Object key)
Description copied from interface: `Cache`
Evict the mapping for this key from this cache if it is present, expecting the key to be immediately invisible for subsequent lookups.

The default implementation delegates to `Cache.evict(Object)`, returning `false` for not-determined prior presence of the key. Cache providers and in particular cache decorators are encouraged to perform immediate eviction if possible (for example, in case of generally deferred cache operations within a transaction) and to reliably determine prior presence of the given key.

Specified by:
  `evictIfPresent` in interface `Cache`
Parameters:
  `key` - the key whose mapping is to be removed from the cache
Returns:
  `true` if the cache was known to have a mapping for this key before, `false` if it did not (or if prior presence could not be determined)
See Also:
  - `Cache.evict(Object)`

### clear

public void clear()
Description copied from interface: `Cache`
Clear the cache through removing all mappings.

Actual clearing may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly still seeing the entries. This may for example be the case with transactional cache decorators. Use `Cache.invalidate()` for guaranteed immediate removal of entries.

If the cache is supposed to be compatible with `CompletableFuture` and reactive interactions, the clear operation needs to be effectively non-blocking, with any backend write-through happening asynchronously. This goes along with a cache implemented and configured to support `Cache.retrieve(Object)` and `Cache.retrieve(Object, Supplier)`.

Specified by:
  `clear` in interface `Cache`
See Also:
  - `Cache.invalidate()`

### invalidate

public boolean invalidate()
Description copied from interface: `Cache`
Invalidate the cache through removing all mappings, expecting all entries to be immediately invisible for subsequent lookups.

Specified by:
  `invalidate` in interface `Cache`
Returns:
  `true` if the cache was known to have mappings before, `false` if it did not (or if prior presence of entries could not be determined)
See Also:
  - `Cache.clear()`